﻿Enumeration
  #s1
  #s2
  #bc1
  #bc2
  #opt_com
  #opt_no
  #opt_sp
  #opt_tab
  #lz80
  #l8080
EndEnumeration


Procedure.s mytrim(s.s)
  
  ; Debug s
  p=1;chr(09)
  While p
    p=FindString(s,Chr(09))
    If p
      s=ReplaceString(s,Chr(09)," ")
    EndIf
  Wend
  
  p=1;chr(32)
  While p
    p=FindString(s,"  ")
    If p
      s=ReplaceString(s,"  "," ")
    EndIf
  Wend
  
  ; Debug s
  
  ProcedureReturn s
EndProcedure


Procedure convert()
  ClearGadgetItems(#s2)
  ln=CountGadgetItems(#s1);amount of lines
                          ;regex
  CreateRegularExpression(0, "ld [abcdehl\(hl\)]..[abcdehl\(hl\)]..",#PB_RegularExpression_NoCase )
  
  CreateRegularExpression(2, "i[x|y]?[-|,|+|h|l]")
  
  CreateRegularExpression(3, "ld a,\(.*?\)")
  CreateRegularExpression(4, "ld \(.*?\),a")
  CreateRegularExpression(5, "(adc|sbc) hl,(bc|de|hl|sp)")
  
  If ln>0
    For i=0 To ln
      s.s=mytrim(GetGadgetItemText(#s1,i))
      s1.s=s
      ;IX;IY   i[x|y]?[-|,|+|h|l]
      If MatchRegularExpression(2, LCase(s))
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      ;ld bc,() ld de,() ld sp,() - illegal and ld(),bc de sp
      
      ;ld sp,hl
      If FindString(s,"ld sp,hl",0,#PB_String_NoCase)
        s=ReplaceString(s,"ld sp,hl","sphl",#PB_String_NoCase)
      EndIf  
      ;ld (),hl;-shld
      CreateRegularExpression(1, "ld \(.*?\),hl")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"ld (","shld ",#PB_String_NoCase)
        s=ReplaceString(s,"),hl","",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;ld hl,()???
      If FindString(s,"ld hl,(",0,#PB_String_NoCase)
        s=ReplaceString(s,"ld hl,(","lhld ",#PB_String_NoCase);неверное
        j=Len(s)
        While j>0
          If Mid(s,j,1)=")"
            s=ReplaceString(s,")","",#PB_String_NoCase,j)
            j=0
          EndIf
          j=j-1
        Wend
      EndIf
      
      ;ld hl, bc, de, sp,
      s=ReplaceString(s,"ld sp,","lxi sp,",#PB_String_NoCase)
      s=ReplaceString(s,"ld bc,","lxi b,",#PB_String_NoCase)
      s=ReplaceString(s,"ld de,","lxi d,",#PB_String_NoCase)
      s=ReplaceString(s,"ld hl,","lxi h,",#PB_String_NoCase)
      
      ;ld a,(de) ld a,(bc) ld (de),a ld (bc),a
      s=ReplaceString(s,"ld (bc),a","stax b",#PB_String_NoCase)
      s=ReplaceString(s,"ld a,(bc)","ldax b",#PB_String_NoCase)
      s=ReplaceString(s,"ld (de),a","stax d",#PB_String_NoCase)
      s=ReplaceString(s,"ld a,(de)","ldax d",#PB_String_NoCase)
      
      
      ;ld \(hl\),[a|b|c|d|e|h|l] - ld(hl),r8
      ; (?i) i  For PCRE_CASELESS
      CreateRegularExpression(1, "ld \(hl\),[a|b|c|d|e|h|l]")
      If MatchRegularExpression(1, LCase(s) )
        s=ReplaceString(s,"ld ","mov ",#PB_String_NoCase)
        s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;ld (hl),NN-MVI M,byte 
      If FindString(s,"ld (hl),",0,#PB_String_NoCase)
        s=ReplaceString(s,"ld (hl),","mvi m,",#PB_String_NoCase)
      EndIf
      
      ;ld [a|b|c|d|e|h|l],\(hl\) - ld r8,(hl)
      CreateRegularExpression(1, "ld [a|b|c|d|e|h|l],\(hl\)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"ld ","mov ",#PB_String_NoCase)
        s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;ld [a|b|c|d|e|h|l]\x2C[a|b|c|d|e|h|l]-ld r8,r8
      CreateRegularExpression(1, "ld [a|b|c|d|e|h|l]\x2C[a|b|c|d|e|h|l]")
      If MatchRegularExpression(1, LCase(s) )
        s=ReplaceString(s,"ld ","mov ",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;ld a,(a16)|ld (a16),a - LDA STA
      CreateRegularExpression(1, "ld a,\(.*?\)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"ld a,(","lda ",#PB_String_NoCase)
        j=Len(s)
        While j>0
          If Mid(s,j,1)=")"
            s=ReplaceString(s,")","",#PB_String_NoCase,j)
            j=0
          EndIf
          j=j-1
        Wend
      EndIf
      FreeRegularExpression(1)
      
      CreateRegularExpression(1, "ld \(.*?\),a")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"ld (","sta ",#PB_String_NoCase)
        s=ReplaceString(s,"),a","",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;ld a, NN -ld [a|b|c|d|e|h|l],?.*
      CreateRegularExpression(1, "ld [a|b|c|d|e|h|l],?.*")
      If MatchRegularExpression(1, LCase(s) )
        s=ReplaceString(s,"ld ","mvi ",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;XCHG  EX DE,HL
      If FindString(s,"ex de,hl",0,#PB_String_NoCase)
        s=ReplaceString(s,"ex de,hl","xchg",#PB_String_NoCase)
      EndIf
      
      ;XTHL  EX (SP),HL
      If FindString(s,"ex (sp),hl",0,#PB_String_NoCase)
        s=ReplaceString(s,"ex (sp),hl","xthl",#PB_String_NoCase)
      EndIf
      
      ;EX AF,AF' EXX - illegal
      If FindString(s,"ex af,af'",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"exx",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      ;jp nz,-jnz jp z,-jz,jnc-jp nc,jc-jp c,jp po, -jpo
      s=ReplaceString(s,"jp nz,","jnz ",#PB_String_NoCase)
      s=ReplaceString(s,"jp z,","jz ",#PB_String_NoCase)
      
      s=ReplaceString(s,"jp nc,","jnc ",#PB_String_NoCase)
      s=ReplaceString(s,"jp c,","jc ",#PB_String_NoCase)
      
      s=ReplaceString(s,"jp po,","jpo ",#PB_String_NoCase)
      s=ReplaceString(s,"jp pe,","jpe ",#PB_String_NoCase)
      
      If Not FindString(s,"jp p,",0,#PB_String_NoCase)
        s=ReplaceString(s,"jp ","jmp ",#PB_String_NoCase)
      Else
        s=ReplaceString(s,"jp p,","jp ",#PB_String_NoCase)
      EndIf
      
      s=ReplaceString(s,"jp m,","jm ",#PB_String_NoCase)
      
      ;pchl
      If FindString(s,"jp (hl)",0,#PB_String_NoCase)
        s=ReplaceString(s,"jp (hl)","pchl",#PB_String_NoCase)
      EndIf
      
      ;add a,[a|b|c|d|e|h|l]
      If FindString(s,"add a,",0,#PB_String_NoCase)
        CreateRegularExpression(1, "add a,[a|b|c|d|e|h|l]")
        If MatchRegularExpression(1, LCase(s))
          s=ReplaceString(s,"add a,","add ",#PB_String_NoCase)
        EndIf
        FreeRegularExpression(1)
        ;add a,(hl) add m
        s=ReplaceString(s,"add a,(hl)","add m",#PB_String_NoCase)
        ;adi byte - add a,byte
        s=ReplaceString(s,"add a,","adi ",#PB_String_NoCase)
      EndIf
      
      ;adc a,[a|b|c|d|e|h|l|(hl)]
      If FindString(s,"adc a,",0,#PB_String_NoCase)
        CreateRegularExpression(1, "adc a,[a|b|c|d|e|h|l]")
        If MatchRegularExpression(1, LCase(s))
          s=ReplaceString(s,"adc a,","adc ",#PB_String_NoCase)
        EndIf
        FreeRegularExpression(1)
        ;adc a,(hl) adc m
        s=ReplaceString(s,"adc a,(hl)","adc m",#PB_String_NoCase)
        ;aci byte - adc a,byte
        s=ReplaceString(s,"adc a,","aci ",#PB_String_NoCase)
      EndIf
      
      ;sub (hl)
      If FindString(s,"sub",0,#PB_String_NoCase)
        If FindString(s,"sub (hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"sub (hl)","sub m",#PB_String_NoCase)
        Else
          CreateRegularExpression(1, "sub [a|b|c|d|e|h|l]")
          If Not MatchRegularExpression(1, LCase(s))
            s=ReplaceString(s,"sub","sui ",#PB_String_NoCase)
          EndIf
          FreeRegularExpression(1)
        EndIf
      EndIf
      
      ;sbc abcdehl(hl)
      If FindString(s,"sbc",0,#PB_String_NoCase)
        If FindString(s,"sbc (hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"sbc (hl)","sbb m",#PB_String_NoCase)
        Else
          CreateRegularExpression(1, "sbc [a|b|c|d|e|h|l]")
          If Not MatchRegularExpression(1, LCase(s))
            s=ReplaceString(s,"sbc","sbi ",#PB_String_NoCase)
          EndIf
          FreeRegularExpression(1)
        EndIf
      EndIf
      
      ;dad b d h sp -add hl,bc|de|hl|sp -add hl,(bc|de|hl|sp)
      CreateRegularExpression(1, "add hl,(bc|de|hl|sp)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"add hl,bc","dad b",#PB_String_NoCase)
        s=ReplaceString(s,"add hl,de","dad d",#PB_String_NoCase)
        s=ReplaceString(s,"add hl,hl","dad h",#PB_String_NoCase)
        s=ReplaceString(s,"add hl,sp","dad sp",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;adc/sbc hl,bc|de|hl|sp - illegal-(adc|sbc) hl,(bc|de|hl|sp)
      If MatchRegularExpression(5, LCase(s))
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      ;di/ei/nop/hlt - ok
      
      ;inx b|d|h|sp - inc bc,de,hl,sp
      CreateRegularExpression(1, "inc (bc|de|hl|sp)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"inc bc","inx b",#PB_String_NoCase)
        s=ReplaceString(s,"inc de","inx d",#PB_String_NoCase)
        s=ReplaceString(s,"inc hl","inx h",#PB_String_NoCase)
        s=ReplaceString(s,"inc sp","inx sp",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;dcx b|d|h|sp - dec bc,de,hl,sp
      CreateRegularExpression(1, "dec (bc|de|hl|sp)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"dec bc","dcx b",#PB_String_NoCase)
        s=ReplaceString(s,"dec de","dcx d",#PB_String_NoCase)
        s=ReplaceString(s,"dec hl","dcx h",#PB_String_NoCase)
        s=ReplaceString(s,"dec sp","dcx sp",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;inc (a|b|c|d|e|h|l|\(hl\))-INR
      CreateRegularExpression(1, "inc (a|b|c|d|e|h|l|\(hl\))")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"inc ","inr ",#PB_String_NoCase)
        s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      
      ;dec (a|b|c|d|e|h|l|\(hl\))-DCR
      CreateRegularExpression(1, "dec (a|b|c|d|e|h|l|\(hl\))")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"dec ","dcr ",#PB_String_NoCase)
        s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      ;daa-daa
      ;cma-cpl
      If FindString(s,"cpl",0,#PB_String_NoCase)
        s=ReplaceString(s,"cpl","cma",#PB_String_NoCase)
      EndIf
      ;stc-scf
      If FindString(s,"scf",0,#PB_String_NoCase)
        s=ReplaceString(s,"scf","stc",#PB_String_NoCase)
      EndIf
      ;cmc-ccf
      If FindString(s,"ccf",0,#PB_String_NoCase)
        s=ReplaceString(s,"ccf","cmc",#PB_String_NoCase)
      EndIf
      ;neg-illegal
      If FindString(s,"neg",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      ;shifts
      ;RLCA-RLC -- (rlca|rrca|rla|rra)
      ;RRCA-RRC
      ;RLA-RAL
      ;RRA-RAR
      CreateRegularExpression(1, "(rlca|rrca|rla|rra)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"rlca","rlc",#PB_String_NoCase)
        s=ReplaceString(s,"rrca","rrc",#PB_String_NoCase)
        s=ReplaceString(s,"rla","ral",#PB_String_NoCase)
        s=ReplaceString(s,"rra","rar",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      ;check illegal
      If FindString(s,"rld",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"rrd",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      ;(rlc|rl|rrc|) (a|b|c|d|e|h|l|\(hl\))
      CreateRegularExpression(1, "(rlc|rl|rrc|rr) (a|b|c|d|e|h|l|\(hl\))")
      If MatchRegularExpression(1, LCase(s))
        FreeRegularExpression(1)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      Else
        FreeRegularExpression(1)
      EndIf
      
      ;and abcdehl(hl)-ANA
      If FindString(s,"and ",0,#PB_String_NoCase)
        If FindString(s,"and (hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"and (hl)","ana m",#PB_String_NoCase)
        Else
          CreateRegularExpression(1, "and [a|b|c|d|e|h|l]")
          If Not MatchRegularExpression(1, LCase(s))
            s=ReplaceString(s,"and","ani ",#PB_String_NoCase)
          Else
            s=ReplaceString(s,"and","ana ",#PB_String_NoCase)
          EndIf
          FreeRegularExpression(1)
        EndIf
      EndIf
      
      ;xor abcdehl(hl)-XRA
      If FindString(s,"xor ",0,#PB_String_NoCase)
        If FindString(s,"xor (hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"xor (hl)","xra m",#PB_String_NoCase)
        Else
          CreateRegularExpression(1, "xor [a|b|c|d|e|h|l]")
          If Not MatchRegularExpression(1, LCase(s))
            s=ReplaceString(s,"xor","xri ",#PB_String_NoCase)
          Else
            s=ReplaceString(s,"xor","xra ",#PB_String_NoCase)
          EndIf
          FreeRegularExpression(1)
        EndIf
      EndIf
      
      ;or abcdehl(hl)-ORA
      If FindString(s,"or ",0,#PB_String_NoCase)
        If FindString(s,"or (hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"or (hl)","ora m",#PB_String_NoCase)
        Else
          CreateRegularExpression(1, "or [a|b|c|d|e|h|l]")
          If Not MatchRegularExpression(1, LCase(s))
            s=ReplaceString(s,"or","ori ",#PB_String_NoCase)
          Else
            s=ReplaceString(s,"or","ora ",#PB_String_NoCase)
          EndIf
          FreeRegularExpression(1)
        EndIf
      EndIf
      
;CPI
      If FindString(s,"cpi",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf

      ;cp abcdehl(hl)-CMP
      If FindString(s,"cp ",0,#PB_String_NoCase)
        If FindString(s,"cp (hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"cp (hl)","cmp m",#PB_String_NoCase)
        Else
          CreateRegularExpression(1, "cp [a|b|c|d|e|h|l]")
          If Not MatchRegularExpression(1, LCase(s))
            s=ReplaceString(s,"cp ","cpi ",#PB_String_NoCase)
          Else
            s=ReplaceString(s,"cp ","cmp ",#PB_String_NoCase)
          EndIf
          FreeRegularExpression(1)
        EndIf
      EndIf
      
      ;CPI,CPIR,CPD,CPDR
      If FindString(s,"cpir",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"cpd",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      If FindString(s,"cpdr",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      ; jr branches djnz
      If FindString(s,"jr",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"djnz",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      ;call condition
      ;cnz call nz,
      If FindString(s,"call nz,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call nz, ","cnz ",#PB_String_NoCase)
      EndIf
      
      ;cz call z,
      If FindString(s,"call z,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call z, ","cz ",#PB_String_NoCase)
      EndIf
      
      ;cnc call nc,
      If FindString(s,"call nc,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call nc, ","cnc ",#PB_String_NoCase)
      EndIf
      
      ;cc call c,
      If FindString(s,"call c,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call c, ","cc ",#PB_String_NoCase)
      EndIf
      
      ;cpo call po,
      If FindString(s,"call po,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call po, ","cpo ",#PB_String_NoCase)
      EndIf
      
      ;cpe call pe,
      If FindString(s,"call pe,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call pe, ","cpe ",#PB_String_NoCase)
      EndIf
      
      ;cp call p,
      If FindString(s,"call p,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call p, ","cp ",#PB_String_NoCase)
      EndIf
      
      ;cm call m,
      If FindString(s,"call m,",0,#PB_String_NoCase)
        s=ReplaceString(s,"call m, ","cm ",#PB_String_NoCase)
      EndIf
      
      ;ret condition
      ;rnz ret nz
      If FindString(s,"ret nz",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret nz","rnz",#PB_String_NoCase)
      EndIf
      
      ;rz ret z
      If FindString(s,"ret z",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret z","rz",#PB_String_NoCase)
      EndIf
      
      ;rnc ret nc
      If FindString(s,"ret nc",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret nc","rnc",#PB_String_NoCase)
      EndIf
      
      ;rc ret c
      If FindString(s,"ret c",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret c","rc",#PB_String_NoCase)
      EndIf
      
      ;rpo ret po
      If FindString(s,"ret po",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret po","rpo",#PB_String_NoCase)
      EndIf
      
      ;rpe ret pe
      If FindString(s,"ret pe",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret pe","rpe",#PB_String_NoCase)
      EndIf
      
      ;rp ret p
      If FindString(s,"ret p",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret p","rp",#PB_String_NoCase)
      EndIf
      
      ;rm ret m
      If FindString(s,"ret m",0,#PB_String_NoCase)
        s=ReplaceString(s,"ret m","rm",#PB_String_NoCase)
      EndIf
      
      ;reti retn -illegal
      If FindString(s,"reti",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"retn",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      ;rst 0 1 2 3 4 5 6 7 rst 0 8 10h 18h 20h 28h 30h 38h
      ;rst [0-9a-fA-F]+h*
      CreateRegularExpression(1, "rst [0-9a-fA-F]+h*")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"rst ","",#PB_String_NoCase)
        rs=Val("$"+s)>>3
        s="rst "+Str(rs)
;        s="rst "+RSet( Hex(rs,#PB_Byte),2,"0")
      EndIf
      FreeRegularExpression(1)

      ;push bc,de,hl,af
      If FindString(s,"push bc",0,#PB_String_NoCase)
        s=ReplaceString(s,"push bc","push b",#PB_String_NoCase)
      EndIf
      If FindString(s,"push de",0,#PB_String_NoCase)
        s=ReplaceString(s,"push de","push d",#PB_String_NoCase)
      EndIf
      If FindString(s,"push hl",0,#PB_String_NoCase)
        s=ReplaceString(s,"push hl","push h",#PB_String_NoCase)
      EndIf
      If FindString(s,"push af",0,#PB_String_NoCase)
        s=ReplaceString(s,"push af","push psw",#PB_String_NoCase)
      EndIf
      ;pop bc,de,hl,af
      If FindString(s,"pop bc",0,#PB_String_NoCase)
        s=ReplaceString(s,"pop bc","pop b",#PB_String_NoCase)
      EndIf
      If FindString(s,"pop de",0,#PB_String_NoCase)
        s=ReplaceString(s,"pop de","pop d",#PB_String_NoCase)
      EndIf
      If FindString(s,"pop hl",0,#PB_String_NoCase)
        s=ReplaceString(s,"pop hl","pop h",#PB_String_NoCase)
      EndIf
      If FindString(s,"pop af",0,#PB_String_NoCase)
        s=ReplaceString(s,"pop af","pop psw",#PB_String_NoCase)
      EndIf
      
      ;INI INIR IND INDR OUTI OTIR OUTD OTDR-illegal
      ;IN OUT
      
      ;INI INIR IND INDR;in[id]r*
      CreateRegularExpression(1, "in[id]r*")
      If MatchRegularExpression(1, LCase(s))
        FreeRegularExpression(1)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      Else
        FreeRegularExpression(1)
      EndIf
;in (a|b|c|d|e|h|l)\x2C\(c\)
          CreateRegularExpression(1, "in (a|b|c|d|e|h|l)\x2C\(c\)")
          If MatchRegularExpression(1, LCase(s))
            FreeRegularExpression(1)
            s="; illegal opcode:"+s
            s1=""
            Goto put_n
          Else
            FreeRegularExpression(1)
          EndIf

;in a,(byte) IN byte
      If FindString(s,"in a,(",0,#PB_String_NoCase)
        s=ReplaceString(s,"in a,(","in ",#PB_String_NoCase)
        j=Len(s)
        While j>0
          If Mid(s,j,1)=")"
            s=ReplaceString(s,")","",#PB_String_NoCase,j)
            j=0
          EndIf
          j=j-1
        Wend
      EndIf

;OUTI OTIR OUTD OTDR
      If FindString(s,"outi",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"otir",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf

      If FindString(s,"outd",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf

      If FindString(s,"otdr",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
;out (c),a - out \(c\)\x2C(a|b|c|d|e|h|l)
      CreateRegularExpression(1, "out \(c\)\x2C(a|b|c|d|e|h|l)")
      If MatchRegularExpression(1, LCase(s))
        FreeRegularExpression(1)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      Else
        FreeRegularExpression(1)
      EndIf

;OUT byte out (byte),a
      If FindString(s,"out (",0,#PB_String_NoCase)
        s=ReplaceString(s,"out (","out ",#PB_String_NoCase)
        s=ReplaceString(s,"),a","",#PB_String_NoCase)
      EndIf

;LDI LDIR LDD LDDR;ld[id]r*
      CreateRegularExpression(1, "ld[id]r*")
      If MatchRegularExpression(1, LCase(s))
        FreeRegularExpression(1)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      Else
        FreeRegularExpression(1)
      EndIf

;bit/res/set 0-7,r8 (bit|set|res) [0-7]\x2C(a|b|c|d|e|h|l|\(hl\))
      CreateRegularExpression(1, "(bit|set|res) [0-7]\x2C(a|b|c|d|e|h|l|\(hl\))")
      If MatchRegularExpression(1, LCase(s))
        FreeRegularExpression(1)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      Else
        FreeRegularExpression(1)
      EndIf
      
      ;sla/sra/srl - illegal
      If FindString(s,"sla",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"sra",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      If FindString(s,"srl",0,#PB_String_NoCase)
        s="; illegal opcode:"+s
        s1=""
        Goto put_n
      EndIf
      
      put_n:
      s=Trim(s," ")
      If GetGadgetState(#opt_com)
        s=s+" ; "+s1
      EndIf
      ;separators
      sep.s=""
      If GetGadgetState(#opt_tab):sep=Chr(9):EndIf
      If GetGadgetState(#opt_sp):sep=Chr(32):EndIf
      If GetGadgetState(#opt_no):sep="":EndIf
      
      AddGadgetItem(#s2,-1,sep+s)
    Next i
  EndIf

  FreeRegularExpression(0)
  FreeRegularExpression(2)
  FreeRegularExpression(3)
  FreeRegularExpression(4)
  FreeRegularExpression(5)
EndProcedure
 
Procedure convert2()
  ClearGadgetItems(#s1)
   ln=CountGadgetItems(#s2);amount of lines
   If ln>0
     For i=0 To ln
       s.s=mytrim(GetGadgetItemText(#s2,i))
       s1.s=s
       ;go!
       
       If FindString(s,"mov ",0,#PB_String_NoCase);mov a,b
         s=ReplaceString(s,"mov ","ld ",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf

       If FindString(s,"ldax b",0,#PB_String_NoCase);ldax b
         s=ReplaceString(s,"ldax b","ld a,(bc)",#PB_String_NoCase)
      EndIf

       If FindString(s,"ldax d",0,#PB_String_NoCase);ldax d
         s=ReplaceString(s,"ldax d","ld a,(de)",#PB_String_NoCase)
      EndIf

        If FindString(s,"lda ",0,#PB_String_NoCase);lda word ld a,(word)
          s=ReplaceString(s,"lda ","ld a,(",#PB_String_NoCase)+")"
       EndIf

       If FindString(s,"mvi ",0,#PB_String_NoCase);mvi r8,byte
         s=ReplaceString(s,"mvi ","ld ",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf

       If FindString(s,"stax b",0,#PB_String_NoCase);stax b
         s=ReplaceString(s,"stax b","ld (bc),a",#PB_String_NoCase)
      EndIf

       If FindString(s,"stax d",0,#PB_String_NoCase);stax d
         s=ReplaceString(s,"stax d","ld (de),a",#PB_String_NoCase)
      EndIf

        If FindString(s,"sta ",0,#PB_String_NoCase);sta word ld (word),a
          s=ReplaceString(s,"sta ","ld (",#PB_String_NoCase)+"),a"
       EndIf

       If FindString(s,"lxi b,",0,#PB_String_NoCase);lxi b, ld bc,
         s=ReplaceString(s,"lxi b,","ld bc,",#PB_String_NoCase)
      EndIf

       If FindString(s,"lxi d,",0,#PB_String_NoCase);lxi d, ld de,
         s=ReplaceString(s,"lxi d,","ld de,",#PB_String_NoCase)
      EndIf

       If FindString(s,"lxi h,",0,#PB_String_NoCase);lxi h, ld hl,
         s=ReplaceString(s,"lxi h,","ld hl,",#PB_String_NoCase)
      EndIf

       If FindString(s,"lxi sp,",0,#PB_String_NoCase);lxi sp, ld sp,
         s=ReplaceString(s,"lxi sp,","ld sp,",#PB_String_NoCase)
      EndIf

       If FindString(s,"lhld ",0,#PB_String_NoCase);lhld word
         s=ReplaceString(s,"lhld ","ld hl,(",#PB_String_NoCase)+")"
      EndIf

       If FindString(s,"shld ",0,#PB_String_NoCase);shld word - ld(word),hl
         s=ReplaceString(s,"shld ","ld (",#PB_String_NoCase)+"),hl"
      EndIf

       If FindString(s,"sphl",0,#PB_String_NoCase);sphl ld sp,hl
         s=ReplaceString(s,"sphl","ld sp,hl",#PB_String_NoCase)
      EndIf

       If FindString(s,"xchg",0,#PB_String_NoCase);xchg ex de,hl
         s=ReplaceString(s,"xchg","ex de,hl",#PB_String_NoCase)
      EndIf

       If FindString(s,"xthl",0,#PB_String_NoCase);xthl ex (sp),hl
         s=ReplaceString(s,"xthl","ex (sp),hl",#PB_String_NoCase)
      EndIf

      ;add/adi - add (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "add (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"add ","add a,",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"adi ",0,#PB_String_NoCase);xthl ex (sp),hl
         s=ReplaceString(s,"adi ","add a,",#PB_String_NoCase)
      EndIf

      ;adc/aci - adc (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "adc (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"adc ","adc a,",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"aci ",0,#PB_String_NoCase);xthl ex (sp),hl
         s=ReplaceString(s,"aci ","adc a,",#PB_String_NoCase)
      EndIf

      ;sub/sui - sub (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "sub (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"sub ","sub ",#PB_String_NoCase);;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sub m
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"sui ",0,#PB_String_NoCase);xthl ex (sp),hl
         s=ReplaceString(s,"sui ","sub ",#PB_String_NoCase)
      EndIf

      ;sbb/sbi - sbb (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "sbb (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"sbb ","sbc ",#PB_String_NoCase);;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sub m
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"sbi ",0,#PB_String_NoCase);xthl ex (sp),hl
         s=ReplaceString(s,"sbi ","sbc ",#PB_String_NoCase)
      EndIf

       If FindString(s,"dad b",0,#PB_String_NoCase);dad b add hl,bc
         s=ReplaceString(s,"dad b","add hl,bc",#PB_String_NoCase)
      EndIf

       If FindString(s,"dad d",0,#PB_String_NoCase);dad d add hl,de
         s=ReplaceString(s,"dad d","add hl,de",#PB_String_NoCase)
      EndIf

       If FindString(s,"dad h",0,#PB_String_NoCase);dad h add hl,hl
         s=ReplaceString(s,"dad h","add hl,hl",#PB_String_NoCase)
      EndIf

       If FindString(s,"dad sp",0,#PB_String_NoCase);dad sp add hl,sp
         s=ReplaceString(s,"dad sp","add hl,sp",#PB_String_NoCase)
      EndIf
      
      ;INR - inr (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "inr (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"inr ","inc ",#PB_String_NoCase);;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sub m
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      
      ;DCR - dcr (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "dcr (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"dcr ","dec ",#PB_String_NoCase);;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;sub m
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"inx b",0,#PB_String_NoCase);inx b inc bc
        s=ReplaceString(s,"inx b","inc bc",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"inx d",0,#PB_String_NoCase);inx d inc de
        s=ReplaceString(s,"inx d","inc de",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"inx h",0,#PB_String_NoCase);inx h inc hl
        s=ReplaceString(s,"inx h","inc hl",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"inx sp",0,#PB_String_NoCase);inx sp inc sp
        s=ReplaceString(s,"inx sp","inc sp",#PB_String_NoCase)
      EndIf
      

      If FindString(s,"dcx b",0,#PB_String_NoCase);dcx b dec bc
        s=ReplaceString(s,"dcx b","dec bc",#PB_String_NoCase)
      EndIf

      If FindString(s,"dcx d",0,#PB_String_NoCase);dcx d dec de
        s=ReplaceString(s,"dcx d","dec de",#PB_String_NoCase)
      EndIf

      If FindString(s,"dcx h",0,#PB_String_NoCase);dcx h dec hl
        s=ReplaceString(s,"dcx h","dec hl",#PB_String_NoCase)
      EndIf

      If FindString(s,"dcx sp",0,#PB_String_NoCase);dcx sp dec sp
        s=ReplaceString(s,"dcx sp","dec sp",#PB_String_NoCase)
      EndIf


      If FindString(s,"cma",0,#PB_String_NoCase);cma cpl
        s=ReplaceString(s,"cma","cpl",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"stc",0,#PB_String_NoCase);stc scf
        s=ReplaceString(s,"stc","scf",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"cmc",0,#PB_String_NoCase);cmc ccf
        s=ReplaceString(s,"cmc","ccf",#PB_String_NoCase)
      EndIf

      ;rlc-rlca
      If FindString(s,"rlc",0,#PB_String_NoCase)
        s=ReplaceString(s,"rlc","rlca",#PB_String_NoCase)
      EndIf
      ;rrc-rrca
      If FindString(s,"rrc",0,#PB_String_NoCase)
        s=ReplaceString(s,"rrc","rrca",#PB_String_NoCase)
      EndIf
      ;ral-rla
      If FindString(s,"ral",0,#PB_String_NoCase)
        s=ReplaceString(s,"ral","rla",#PB_String_NoCase)
      EndIf
      ;rar-rra
      If FindString(s,"rar",0,#PB_String_NoCase)
        s=ReplaceString(s,"rar","rra",#PB_String_NoCase)
      EndIf

      ;ana/ani - add (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "ana (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"ana ","and ",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"ani ",0,#PB_String_NoCase);ani byte
         s=ReplaceString(s,"ani ","and ",#PB_String_NoCase)
       EndIf
       
      ;xra/xri - xra (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "xra (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"xra ","xor ",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"xri ",0,#PB_String_NoCase);xri byte
         s=ReplaceString(s,"xri ","xor ",#PB_String_NoCase)
       EndIf
       
      ;ora/ori - ora (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "ora (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"ora ","or ",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"ori ",0,#PB_String_NoCase);ori byte
         s=ReplaceString(s,"ori ","or ",#PB_String_NoCase)
       EndIf

      ;cmp/cpi - cmp (a|b|c|d|e|h|l|m)
      CreateRegularExpression(1, "cmp (a|b|c|d|e|h|l|m)")
      If MatchRegularExpression(1, LCase(s))
        s=ReplaceString(s,"cmp ","cp ",#PB_String_NoCase)
         ;m->(hl)
         s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
      EndIf
      FreeRegularExpression(1)
      If FindString(s,"cpi ",0,#PB_String_NoCase);cpi byte
        s=ReplaceString(s,"cpi ","cp ",#PB_String_NoCase)
        Goto put_t
       EndIf
       
       ;jumps
       
       If FindString(s,"jp ",0,#PB_String_NoCase);jp-jp p,
         s=ReplaceString(s,"jp ","jp p,",#PB_String_NoCase)
       EndIf

      If FindString(s,"jmp ",0,#PB_String_NoCase);jmp-jp 
        s=ReplaceString(s,"jmp ","jp ",#PB_String_NoCase)
        Goto put_t
      EndIf

      If FindString(s,"jnz ",0,#PB_String_NoCase);jnz-jp nz,
        s=ReplaceString(s,"jnz ","jp nz,",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"jz ",0,#PB_String_NoCase);jz-jp z,
        s=ReplaceString(s,"jz ","jp z,",#PB_String_NoCase)
      EndIf

      If FindString(s,"jnc ",0,#PB_String_NoCase);jnc-jp nc,
        s=ReplaceString(s,"jnc ","jp nc,",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"jc ",0,#PB_String_NoCase);jc-jp c,
        s=ReplaceString(s,"jc ","jp c,",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"jpo ",0,#PB_String_NoCase);jpo-jp po,
        s=ReplaceString(s,"jpo ","jp po,",#PB_String_NoCase)
      EndIf

      If FindString(s,"jpe ",0,#PB_String_NoCase);jpe-jp pe,
        s=ReplaceString(s,"jpe ","jp pe,",#PB_String_NoCase)
      EndIf
      
;       If FindString(s,"jp ",0,#PB_String_NoCase);jp-jp p,
;         s=ReplaceString(s,"jp ","jp p,",#PB_String_NoCase)
;       EndIf
      
      If FindString(s,"jm ",0,#PB_String_NoCase);jm-jp m,
        s=ReplaceString(s,"jm ","jp m,",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"pchl",0,#PB_String_NoCase);pchl jp (hl)
        s=ReplaceString(s,"pchl","jp(hl)",#PB_String_NoCase)
      EndIf
      
      ;calls
       If FindString(s,"cnz ",0,#PB_String_NoCase);cnz-call nz,
        s=ReplaceString(s,"cnz ","call nz,",#PB_String_NoCase)
      EndIf

      If FindString(s,"cz ",0,#PB_String_NoCase);cz-call z,
        s=ReplaceString(s,"cz ","call z,",#PB_String_NoCase)
      EndIf

      If FindString(s,"cnc ",0,#PB_String_NoCase);cnc-call nc,
        s=ReplaceString(s,"cnc ","call nc,",#PB_String_NoCase)
      EndIf

      If FindString(s,"cc ",0,#PB_String_NoCase);cc-call c,
        s=ReplaceString(s,"cc ","call c,",#PB_String_NoCase)
      EndIf

      If FindString(s,"cpo ",0,#PB_String_NoCase);cpo-call po,
        s=ReplaceString(s,"cpo ","call po,",#PB_String_NoCase)
      EndIf

      If FindString(s,"cpe ",0,#PB_String_NoCase);cpe-call pe,
        s=ReplaceString(s,"cpe ","call pe,",#PB_String_NoCase)
      EndIf

      If FindString(s,"cp ",0,#PB_String_NoCase);cp-call p,
        s=ReplaceString(s,"cp ","call p,",#PB_String_NoCase)
      EndIf

      If FindString(s,"cm ",0,#PB_String_NoCase);cm-cp m,
        s=ReplaceString(s,"cm ","call m,",#PB_String_NoCase)
      EndIf

      ;rets
      If FindString(s,"rnz",0,#PB_String_NoCase);rnz ret nz
        s=ReplaceString(s,"rnz","ret nz",#PB_String_NoCase)
      EndIf

      If FindString(s,"rz",0,#PB_String_NoCase);rz ret z
        s=ReplaceString(s,"rz","ret z",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"rnc",0,#PB_String_NoCase);rnc ret nc
        s=ReplaceString(s,"rnc","ret nc",#PB_String_NoCase)
      EndIf

      If FindString(s,"rc",0,#PB_String_NoCase);rc ret c
        s=ReplaceString(s,"rc","ret c",#PB_String_NoCase)
      EndIf

      If FindString(s,"rpo",0,#PB_String_NoCase);rpo ret cpo
        s=ReplaceString(s,"rpo","ret po",#PB_String_NoCase)
      EndIf

      If FindString(s,"rpe",0,#PB_String_NoCase);rpe ret cpe
        s=ReplaceString(s,"rpe","ret pe",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"rp",0,#PB_String_NoCase);rp ret p
        s=ReplaceString(s,"rp","ret p",#PB_String_NoCase)
      EndIf
      
      If FindString(s,"rm",0,#PB_String_NoCase);rm ret m
        s=ReplaceString(s,"rm","ret m",#PB_String_NoCase)
      EndIf
      
      ;rst 0-7
      ;push bc,de,hl,af
      If FindString(s,"push b",0,#PB_String_NoCase);push b push bc
        s=ReplaceString(s,"push b","push bc",#PB_String_NoCase)
      EndIf

      If FindString(s,"push d",0,#PB_String_NoCase);push d push de
        s=ReplaceString(s,"push d","push de",#PB_String_NoCase)
      EndIf

      If FindString(s,"push h",0,#PB_String_NoCase);push h push hl
        s=ReplaceString(s,"push h","push hl",#PB_String_NoCase)
      EndIf

      If FindString(s,"push psw",0,#PB_String_NoCase);push psw push af
        s=ReplaceString(s,"push psw","push af",#PB_String_NoCase)
      EndIf

      ;pop bc,de,hl,af
      If FindString(s,"pop b",0,#PB_String_NoCase);pop b pop bc
        s=ReplaceString(s,"pop b","pop bc",#PB_String_NoCase)
      EndIf

      If FindString(s,"pop d",0,#PB_String_NoCase);pop d pop de
        s=ReplaceString(s,"pop d","pop de",#PB_String_NoCase)
      EndIf

      If FindString(s,"pop h",0,#PB_String_NoCase);pop h pop hl
        s=ReplaceString(s,"pop h","pop hl",#PB_String_NoCase)
      EndIf

      If FindString(s,"pop psw",0,#PB_String_NoCase);pop psw pop af
        s=ReplaceString(s,"pop psw","pop af",#PB_String_NoCase)
      EndIf

      ;in byte in a,(byte)
      If FindString(s,"in ",0,#PB_String_NoCase)
        s=ReplaceString(s,"in ","in a,(",#PB_String_NoCase)+")"
      EndIf

      ;out byte out (byte),a
      If FindString(s,"out ",0,#PB_String_NoCase)
        s=ReplaceString(s,"out ","out (",#PB_String_NoCase)+"),a"
      EndIf

put_t:
       s=Trim(s," ")
       If GetGadgetState(#opt_com)
         s=s+" ; "+s1
       EndIf
       ;separators
       sep.s=""
       If GetGadgetState(#opt_tab):sep=Chr(9):EndIf
       If GetGadgetState(#opt_sp):sep=Chr(32):EndIf
       If GetGadgetState(#opt_no):sep="":EndIf
       AddGadgetItem(#s1,-1,sep+s)
     Next i
   EndIf
EndProcedure

Procedure CustomButtonCallback(WindowHandle, Message, WParam, LParam) 
  Shared DefaultButtonCallback

  If Message = #WM_CONTEXTMENU; And WindowHandle=WindowID(#s1)
    DisplayPopupMenu(0, WindowID(#s1));;Debug "Click with right mouse button"
  EndIf

  ProcedureReturn CallWindowProc_(DefaultButtonCallback, WindowHandle, Message, WParam, LParam) 
EndProcedure

Procedure CustomButtonCallback2(WindowHandle, Message, WParam, LParam) 
  Shared DefaultButtonCallback

  If Message = #WM_CONTEXTMENU; And WindowHandle=WindowID(#s1)
    DisplayPopupMenu(1, WindowID(#s1));;Debug "Click with right mouse button"
  EndIf

  ProcedureReturn CallWindowProc_(DefaultButtonCallback, WindowHandle, Message, WParam, LParam) 
EndProcedure

OpenWindow(0, 0, 0, 410, 420, "z80<->8080", #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
EditorGadget(#s1,0,20,190,400);,#PB_Editor_WordWrap);:GadgetToolTip(#s1,"z80 code")
EditorGadget(#s2,220,20,190,400);,#PB_Editor_WordWrap);:GadgetToolTip(#s2,"8080 code")
ButtonGadget(#bc1,191,22,20,20,">"):GadgetToolTip(#bc1,"convert z80 to 8080")
ButtonGadget(#bc2,191,124,20,20,"<"):GadgetToolTip(#bc2,"convert 8080 to z80")
CheckBoxGadget(#opt_com,191,44,20,20,";"):GadgetToolTip(#opt_com,"add mnemonics after ';'")
OptionGadget(#opt_no,191,64,20,20,"x"):GadgetToolTip(#opt_no,"no separator for line")
OptionGadget(#opt_sp,191,84,20,20,"s"):GadgetToolTip(#opt_sp,"use space separator")
OptionGadget(#opt_tab,191,104,20,20,"t"):GadgetToolTip(#opt_tab,"usetab separator instead of space")
TextGadget(#lz80,0,0,190,20,"z80 code", #PB_Text_Center | #PB_Text_Border)
TextGadget(#l8080,220,0,190,20,"8080 code", #PB_Text_Center | #PB_Text_Border)

SetGadgetState(#opt_no,1)

s.s=PeekS(?example)
SetGadgetText(#s1,s)

s.s=PeekS(?ex8080)
SetGadgetText(#s2,s)

EnableGadgetDrop(#s1,#PB_Drop_Files,#PB_Drag_Copy)
EnableGadgetDrop(#s2,#PB_Drop_Files,#PB_Drag_Copy)

  If CreatePopupMenu(0)
    MenuItem(0, "Cut")
    MenuItem(1, "Copy")
    MenuItem(2, "Paste")
    MenuBar()
    MenuItem(3, "Select all")
  EndIf
  
  If CreatePopupMenu(1)
    MenuItem(4, "Cut")
    MenuItem(5, "Copy")
    MenuItem(6, "Paste")
    MenuBar()
    MenuItem(7, "Select All")
  EndIf
  
  
  DefaultButtonCallback = GetWindowLongPtr_(GadgetID(#s1), #GWL_WNDPROC) 
  SetWindowLongPtr_(GadgetID(#s1), #GWL_WNDPROC, @CustomButtonCallback())
  
    DefaultButtonCallback = GetWindowLongPtr_(GadgetID(#s2), #GWL_WNDPROC) 
  SetWindowLongPtr_(GadgetID(#s2), #GWL_WNDPROC, @CustomButtonCallback2())
  Exit = #False

Repeat
  Event = WaitWindowEvent()
;  Event = WindowEvent()
  

  Select Event
    Case #PB_Event_CloseWindow
      Exit = #True
      
      Case #PB_Event_Menu
        Select EventMenu()
          Case 0
            SendMessage_(GadgetID(#s1), #WM_CUT, 0, 0)
          Case 1
            SendMessage_(GadgetID(#s1), #WM_COPY, 0, 0)
          Case 3
            ll=Len(GetGadgetText(#s1))
            SendMessage_(GadgetID(#s1), #EM_SETSEL, 0, ll)
          Case 2
            SendMessage_(GadgetID(#s1), #WM_PASTE, 0, 0)
            
          Case 4
            SendMessage_(GadgetID(#s2), #WM_CUT, 0, 0)
          Case 5
            SendMessage_(GadgetID(#s2), #WM_COPY, 0, 0)
          Case 7
            ll=Len(GetGadgetText(#s2))
            SendMessage_(GadgetID(#s2), #EM_SETSEL, 0, ll)
          Case 6
            SendMessage_(GadgetID(#s2), #WM_PASTE, 0, 0)

        EndSelect

    Case #PB_Event_GadgetDrop
      Select EventGadget()
        Case #s1 To #s2
          gd=EventGadget()
          ClearGadgetItems(gd)
          d$=EventDropFiles()
          ;Debug d$
          If ReadFile(0,d$)
            While Not Eof(0)
              AddGadgetItem(gd,-1,ReadString(0))
            Wend
            CloseFile(0)
          EndIf

      EndSelect

    Case #PB_Event_Gadget
      ID = EventGadget()
      Select ID
        Case #s2
          If EventType() = 1024
            HoldLine = SendMessage_(GadgetID(#s2), #EM_GETFIRSTVISIBLELINE, 0, 0)
            CurrentLine = SendMessage_(GadgetID(#s1), #EM_GETFIRSTVISIBLELINE, 0, 0)
            lResult = SendMessage_(GadgetID(#s1), #EM_LINESCROLL, 0, HoldLine - CurrentLine)
          EndIf
          
        Case #s1
;           Debug Str( EventType() )+"::"+Str(#WM_RBUTTONUP)
;           If EventType()=#WM_RBUTTONUP;DOWN
;             DisplayPopupMenu(0, WindowID(#s1))
;           EndIf
          If EventType() = 1024
            HoldLine = SendMessage_(GadgetID(#s1), #EM_GETFIRSTVISIBLELINE, 0, 0)
            CurrentLine = SendMessage_(GadgetID(#s2), #EM_GETFIRSTVISIBLELINE, 0, 0)
            lResult = SendMessage_(GadgetID(#s2), #EM_LINESCROLL, 0, HoldLine - CurrentLine)
          EndIf

        Case #bc1
          convert()
        Case #bc2
          convert2()
      EndSelect
  EndSelect
;  If (Event = #PB_Event_CloseWindow)
;    Exit = #True
;   ElseIf (Event = #PB_Event_Gadget)
;     ID = EventGadget()
;     Select ID
;       Case 1
;         If (EventType() = #PB_EventType_Change)
;           TestIt()
;         EndIf
;       Case 3
;         If (EventType() = 1024)
;           ;TestIt()
;         EndIf
;       Case 7, 8, 9, 10
;         ;TestIt()
;       Case 11 : StickyWindow(0, GetGadgetState(11))
;       Case 12 : Exit = #True
;     EndSelect
;  EndIf
  
Until Exit

DataSection
  example:
  IncludeBinary "tt.asm"
  Data.l 0
  ex8080:
  IncludeBinary "99boUni.txt"
  Data.l 0
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 1015
; FirstLine = 1000
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = z80-8080.ico
; Executable = z808080.exe